<%@ taglib prefix="json" uri="http://www.atg.com/taglibs/json" %>
<%@ page import="org.apache.axis2.AxisFault" %>
<%@ page import="org.apache.axis2.context.ConfigurationContext" %>
<%@ page import="org.apache.commons.logging.Log" %>
<%@ page import="org.apache.commons.logging.LogFactory" %>
<%@ page import="org.wso2.carbon.CarbonConstants" %>
<%@ page import="org.wso2.carbon.humantask.ui.HumanTaskOperationsClient" %>
<%@ page import="org.wso2.carbon.humantask.ui.api.IllegalArgumentFault" %>
<%@ page import="org.wso2.carbon.humantask.ui.api.IllegalStateFault" %>
<%--<%@ page import="org.wso2.carbon.humantask.ui.api.types.GetMyTaskAbstractsPaginatedResponse" %>--%>
<%@ page import="org.wso2.carbon.ui.CarbonUIUtil" %>
<%@ page import="org.wso2.carbon.utils.ServerConstants" %>
<%@ page import="java.rmi.RemoteException" %>
<%@ page import="org.apache.axis2.databinding.types.URI" %>
<%@ page import="org.wso2.carbon.humantask.ui.api.types.TComment" %>
<%@ page contentType="application/json" %>
<%@ page pageEncoding="UTF-8" %>
<%
    Log log = LogFactory.getLog("task.list.ajaxprocessor");

    response.setHeader("Cache-Control",
            "no-store, max-age=0, no-cache, must-revalidate");

    // Set IE extended HTTP/1.1 no-cache headers.
    response.addHeader("Cache-Control", "post-check=0, pre-check=0");

    // Set standard HTTP/1.0 no-cache header.
    response.setHeader("Pragma", "no-cache");

    String backendServerURL = CarbonUIUtil.getServerURL(config.getServletContext(), session);
    ConfigurationContext configContext =
            (ConfigurationContext) config.getServletContext().getAttribute(CarbonConstants.CONFIGURATION_CONTEXT);

    String cookie = (String) session.getAttribute(ServerConstants.ADMIN_SERVICE_COOKIE);


    String taskId = request.getParameter("task");

    String getMyTasksError = "Error occurred while retrieving comments list.";
    HumanTaskOperationsClient client;

    try {
        client = new HumanTaskOperationsClient(configContext, backendServerURL, cookie);
    } catch (AxisFault e) {
        String errMsg = "Error occurred during HumanTaskOperationsClient creation.";
        log.error(errMsg, e);
        pageContext.setAttribute("error", getMyTasksError);
%>
<json:object>
    <json:property name="error" value="${error}"/>
</json:object>
<%
        return;
    }

    try{
        TComment[] comments = client.getComments(new URI(taskId));
        if(comments!= null && comments.length > 0){
            pageContext.setAttribute("comments", comments);
%>
<json:object>
    <json:array name="comments" var="comment" items="${comments}">
        <json:object>
            <json:property name="addedAt" value="${comment.addedTime}"/>
            <json:property name="addedBy" value="${comment.addedBy}"/>
            <json:property name="text" value="${comment.text}"/>
        </json:object>
    </json:array>
</json:object>
<%
            return;
        }else {
            pageContext.setAttribute("message", "no comments");
%>
<json:object>
    <json:property name="message" value="${message}"/>
</json:object>
<%
            return;
        }
    } catch (Exception e){
        log.error("Error occurred during getComments service operation call.", e);
        String errMsg = "Error occurred during getComments service operation call.";
        pageContext.setAttribute("error", errMsg);
%>
<json:object>
    <json:property name="error" value="${error}"/>
</json:object>
<%
        return;
    }


%>