<%@ taglib prefix="fmt" uri="http://java.sun.com/jsp/jstl/fmt" %>
<%@ taglib uri="http://wso2.org/projects/carbon/taglibs/carbontags.jar" prefix="carbon" %>
<%@ page import="org.apache.axis2.context.ConfigurationContext" %>
<%@ page import="org.wso2.carbon.CarbonConstants" %>
<%@ page import="org.wso2.carbon.ui.CarbonUIUtil" %>
<%@ page import="org.wso2.carbon.utils.ServerConstants" %>
<%@ page import="org.wso2.carbon.humantask.ui.HumanTaskOperationsClient" %>
<%@ page import="org.apache.axis2.databinding.types.URI" %>
<%@ page import="org.wso2.carbon.humantask.ui.api.IllegalAccessFault" %>
<%@ page import="java.rmi.RemoteException" %>
<%@ page import="org.apache.commons.logging.LogFactory" %>
<%@ page import="org.apache.commons.logging.Log" %>
<%@ page import="org.apache.axiom.om.OMElement" %>
<%@ page import="org.wso2.carbon.humantask.ui.api.IllegalArgumentFault" %>
<%@ page import="org.wso2.carbon.humantask.ui.api.IllegalStateFault" %>
<%@ page import="org.wso2.carbon.humantask.ui.api.IllegalOperationFault" %>
<%@ page import="org.apache.axis2.databinding.types.NCName" %>
<carbon:breadcrumb
        label="humantask.newpackage"
        resourceBundle="org.wso2.carbon.humantask.ui.i18n.Resources"
        topPage="true"
        request="<%=request%>"/>
<fmt:bundle basename="org.wso2.carbon.humantask.ui.i18n.Resources">

    <%
        Log log = LogFactory.getLog("task_view_new.jsp");
        String backEndServerURL = CarbonUIUtil.getServerURL(config.getServletContext(), session);
        ConfigurationContext configContext =
                (ConfigurationContext) config.getServletContext().getAttribute(CarbonConstants.CONFIGURATION_CONTEXT);

        String cookie = (String) session.getAttribute(ServerConstants.ADMIN_SERVICE_COOKIE);
        response.setHeader("Cache-Control", "no-store, max-age=0, no-cache, must-revalidate");

        // Set IE extended HTTP/1.1 no-cache headers.
        response.addHeader("Cache-Control", "post-check=0, pre-check=0");

        // Set standard HTTP/1.0 no-cache header.
        response.setHeader("Pragma", "no-cache");

        HumanTaskOperationsClient client = null;
        org.wso2.carbon.humantask.ui.api.types.TTaskAbstract task = null;
        boolean illegalAccess = false;
        String taskID = request.getParameter("taskID");
        String jspContextPath = "";

        try {
            client = new HumanTaskOperationsClient(configContext, backEndServerURL, cookie);
            task = client.loadTask(new URI(taskID));

            String taskName = task.getName().getLocalPart();
            String packageName = task.getPackageName();

            //  /humantask/customui/packagename/taskname.jsp
            jspContextPath = "/humantask/customui/" + packageName + "/" + taskName + ".jsp";

            OMElement requestOM = client.getRequestMessage(new URI(taskID), new NCName(""));
            request.setAttribute("requestOM",requestOM);
        } catch (IllegalAccessFault ex) {
            illegalAccess = true;
            log.error(ex);
        } catch (RemoteException remEx) {
            log.error(remEx);
        } catch (IllegalArgumentFault illArgEx){
            log.error(illArgEx);
        } catch (IllegalStateFault illStateEx){
            log.error(illStateEx);
        } catch (IllegalOperationFault illOpEx){
            log.error(illOpEx);
        }
    %>

    <div id="middle">
            <%-- Header section which contains scripts, styles and imports --%>
        <link type="text/css" href="css/jquery.ui.all.css" rel="stylesheet"/>
        <link type="text/css" href="css/smoothness/jquery-ui-1.8.custom.css" rel="stylesheet"/>
        <link type="text/css" href="css/human-task.css" rel="stylesheet"/>
        <link type="text/css" href="css/xmlverbatim.css" rel="stylesheet"/>
        <script type="text/javascript" src="js/jquery-1.4.2.min.js"></script>
        <script type="text/javascript" src="js/jquery-ui-1.8.custom.min.js"></script>
        <script type="text/javascript" src="js/jquery.createdomnodes.js"></script>

        <%
            if(task ==null){
                %>
            TASK IS NULL
            <%
                return;
            }
        %>

        <script type="text/javascript">

            var tID = <%=taskID%>;
            alert("task ID" + tID );

            $(document).ready(function() {
                loadTaskRequestContent(<%=taskID%>);
                decorateTabs();
                populateComments(<%=taskID%>);
                decorateButtons(<%=taskID%>);
            });

            function loadTaskRequestContent(taskId) {
                var taskRequestContentURL = "task_mockit-ajaxprocessor.jsp";
                jQuery("#taskRequestContent").load(taskRequestContentURL,
                                            {taskId: taskId, type: "REQUEST"},
                                            function(resText, status, res) {
                                                if (status != "success") {
                                                    CARBON.showErrorDialog("Error loading request content");
                                                }
                                            }
                );
            }

            function decorateTabs(){
                $('#tvAdditionalInfoTab').tabs({ fx: { height: 'toggle', opacity: 'toggle' } });
            }

            function decorateButtons(taskID) {
                alert("decorate buttons called...");
                var isClaimable = false;
                var isReleasable = false;
                var isStartable = false;
                var isStopable = false;

                var taskStatus = "<%=task.getStatus().getTStatus()%>";
                var taskType = "<%=task.getTaskType()%>";

                <%
                if(task.getIsClaimable()){
                    %>
                        isClaimable = true;
                <%
                }
                if(task.getIsReleasable()){
                    %>
                        isReleasable = true;
                <%
                }
                if(task.getIsStartable()){
                %>
                        isStartable = true;
                <%
                }
                if(task.getIsStopable()){
                %>
                        isStopable = true;
                <%
                }
                %>
                
                $("#claimTaskButton").button({disabled: !isClaimable}).click(onClaimClick);
                $("#releaseTaskButton").button({disabled: !isReleasable}).click(onReleaseClick);
                $("#startTaskButton").button({disabled: !isStartable}).click(onStartClick);
                $("#stopTaskButton").button({disabled: !isStopable}).click(onStopClick);
                $("#addCommentButton").button({disabled: (taskType != "TASK" || taskStatus == "COMPLETED")}).
                        click(onAddCommentClick);
            }

            function onClaimClick(){
                alert("claim clicked for task:" + tID );
            }

            function onReleaseClick(){
                alert("release clicked");
            }

            function onStartClick(){
                alert("start clicked");
            }

            function onStopClick(){
                alert("stop clicked");
            }

            function onAddCommentClick() {
                var comment = "";

                function addCommentSuccess(response, textStatus, xmlHttpRequest) {
                    handleResponse(response);
                    sandbox.notify({type:"operation-performed", data: null});
                }

                function addCommentFailure(xmlHttpRequest, errorType, exception) {
                    sandbox.notify({
                        type: "show-dialog",
                        data: {
                            type:"INFO",
                            message: "Error adding comment to the task " + currentTask,
                            yesCallback: null
                        }});
                }

                function addComment() {
                    comment = $("#commentText").val();
                    //sandbox.addCommentToTask(currentTask, comment, addCommentSuccess, addCommentFailure);
                    alert("add comment method called :->" + comment);
                }


//                sandbox.notify({
//                    type: "show-dialog",
//                    data: {
//                        type: "CONFIRMATION",
//                        message: "Do you want to add a comment to the task " + tID,
//                        yesCallback: addComment,
//                        noCallback: null
//                    }});

                alert("calling add comment dialog");
                handleShowDialog({
                        type: "CONFIRMATION",
                        message: "Do you want to add a comment to the task " + tID,
                        yesCallback: addComment,
                        noCallback: null
                });
            }


            /**
             * populate the comments list for current
             * @param taskId
             */
            function populateComments(taskId) {

                /**
                 * Populate comments to task view
                 * @param comments  JSON object array.
                 */
                function addCommentsToTaskView(comments) {
                    var commentListHtml = "<ul>"
                    var commentCount = comments.length;
                    for (var i = 0; i < commentCount; i++) {
                        commentListHtml += "<li>" + comments[i].text +
                                           "<br/><span class='commentAuthorTime'>Commented by " +
                                           comments[i].addedBy + " at " + comments[i].addedAt + ".";
                    }

                    commentListHtml += "</ul>";
                    $("#commentList").html(commentListHtml);
                }

                function getCommentsSuccess(response, textStatus, xmlHttpRequest) {
                    if (response !== undefined) {
                        if (response.comments) {
                            addCommentsToTaskView(response.comments);
                        } else if (response.message) {
                            $("#commentList").html("<p>" + response.message + "</p>");
                        } else if (response.error) {
                            $("#commentList").html("<p>" + response.error + "</p>");
                        }
                    }
                }

                function getCommentsFailed(xmlHttpRequest, errorType, exception) {
                    CARBON.showErrorDialog("Error occurred while loading comments to task :" + taskId);
                }

                alert("calling ajax...");

                ajax("comments_list-ajaxprocessor.jsp",
                    {task: taskId},
                    "json",
                    getCommentsSuccess,
                    getCommentsFailed);
            }


            /**
             * Perform an asynchronous HTTP (Ajax) request.
             * @param url              A string containing the URL to which the request is sent.
             * @param data             Data to be sent to the server.
             * @param dataType         The type of data that you're expecting back from the server.
             * @param successCallback  A function to be called if the request succeeds.
             * @param failureCallback  A function to be called if the request fails.
             */
            function ajax(url, data, dataType, successCallback, failureCallback) {
                $.ajax({
                    url: url,
                    type: 'GET',
                    dataType: dataType,
                    data: data,
                    success: successCallback,
                    error: failureCallback
                });
            }

            // dialog disply funtions --------
            function handleShowDialog(eventData) {
                alert("type :" + eventData.type); //TODO - temp remove..
                alert("message :" + eventData.message);
                alert("yes cb :" + eventData.yesCallback);
                alert("no cb: " + eventData.noCallback);
                if (eventData.type == "INFO") {
                    showInfoDialog(eventData.message, eventData.yesCallback);
                } else if (eventData.type == "CONFIRMATION") {
                    showConfirmationDialog(eventData.message, eventData.yesCallback, eventData.noCallback);
                }
            }

            function showInfoDialog(message, okCallback) {
                $("#htDialog").html("<p>" + message + "</p>");

                $("#htDialog").dialog({
                    modal: true,
                    buttons:  {
                        Ok: function() {
                            if (okCallback) {
                                okCallback();
                                $(this).dialog('close');
                            } else {
                                $(this).dialog('close');
                            }
                        }
                    }
                });
            }

            function showConfirmationDialog(message, yesCallback, noCallback) {
                $("#htDialog").html("<p>" + message + "</p>");

                $("#htDialog").dialog({
                    modal: true,
                    buttons:  {
                        "Yes": function() {
                            if (yesCallback !== undefined && typeof yesCallback == "function") {
                                yesCallback();
                                $(this).dialog('close');
                            } else {
                                $(this).dialog('close');
                            }
                        },

                        "No": function() {
                            if (noCallback) {
                                noCallback();
                            } else {
                                $(this).dialog('close');
                            }
                        }
                    }
                });
            }
        // dialog disply funtions --------


        </script>

        <div id="workArea">
        <%
            if (task != null) {
         %>
        <table class="styledLeft" id="taskViewTable">
            <thead>
                <tr>
                    <th class="tvTableHeader" colspan="2">
                        <span style="float:left;padding-top:3px">
                            <%=task.getPresentationName()%>
                        </span>
                    </th>
                </tr>
            </thead>

            <tbody>
                <tr>
                    <td><fmt:message key="humantask.taskview.actions"/></td>
                    <td>
                    <span id="buttonspan" style="float:left;font-size:9px;padding-right:5px;padding-top:3px;padding-bottom:3px;">
                        <button id="claimTaskButton" value="Claim">Claim</button>
                        <button id="releaseTaskButton" value="Release">Release</button>
                        <button id="startTaskButton" value="Start">Start</button>
                        <button id="stopTaskButton" value="Stop">Stop</button>                        
                    </span>
                    </td>

                </tr>

                <tr>
                    <td><fmt:message key="humantask.taskview.subject"/></td>
                    <td><%=task.getPresentationSubject()%></td>
                </tr>

                <tr>
                    <td><fmt:message key="humantask.taskview.type"/></td>
                    <td><%=task.getTaskType()%></td>
                </tr>

                <tr>
                    <td><fmt:message key="humantask.taskview.status"/></td>
                    <td><%=task.getStatus()%></td>
                </tr>

                <tr>
                    <td><fmt:message key="humantask.taskview.priority"/></td>
                    <td><%=task.getPriority()%></td>
                </tr>

                <tr>
                    <td><fmt:message key="humantask.taskview.owner"/></td>
                    <td>
                        <%
                            if(task.getActualOwner() != null){
                                out.print(task.getActualOwner().getTUser());
                            } else {
                                %>
                        <fmt:message key="humantask.taskview.cannot.determine.actual.owner"/>
                        <%
                            }
                        %>

                    </td>
                </tr>

                <tr>
                    <td><fmt:message key="humantask.taskview.createdon"/></td>
                    <td><%=task.getCreatedTime().getTime().toString()%></td>
                </tr>


                <tr>
                    <td colspan="2">
                        <table class="noBorders" style="border:none;width:100%;">
                            <tbody>
                                <tr>
                                    <td  id="taskRequestHeader" style="border-bottom:1px solid #CCCCCC;padding-left:0px">
                                        <span class="tv_underline_header">
                                            <fmt:message key="humantask.taskview.request"/>
                                        </span>

                                    </td>

                                </tr>

                                <tr>
                                    <td id="taskRequestContent" style="padding-left:0px"></td>
                                </tr>

                                <tr>
                                    <td id="taskRequestContent2" style="padding-left:0px">
                                        <div style="background-color:transparent;border:1px solid #CCCCCC;color:#333333;font-family:monospace;padding:4px;">
                                            <jsp:include page="<%=jspContextPath%>"/>
                                        </div>
                                    </td>
                                </tr>

                                <tr>
                                    <td style="padding-left:0px">
                                        <div id="tvAdditionalInfoTab" style="float:none;">
                                            <ul>
                                                <li>
                                                    <a href="#tv_comments"><fmt:message key="humantask.taskview.comments"/></a>
                                                </li>

                                                <li>
                                                    <a href="#tv_attachments"><fmt:message key="humantask.taskview.attachments"/></a>
                                                </li>
                                            </ul>
                                        </div>

                                        <div class="tv_tabdiv" id="tv_comments">
                                            <textarea id="commentText" style="width:100%;"> </textarea>
                                            <button id="addCommentButton"><fmt:message key="humantask.taskview.addcomment"/></button>
                                            <div id="commentList"></div>
                                        </div>

                                        <div class="tv_tabdiv" id="tv_attachments"><fmt:message key="humantask.taskview.attachments.notsupported"/></div>

                                    </td>
                                </tr>
                            </tbody>
                        </table>
                    </td>
                </tr>
            </tbody>

        </table>
                <%
            } else {
            %>
                        <fmt:message key="humantask.taskview.nulltask"/>
                <%
                        if(illegalAccess){
                        %>
                        <p><fmt:message key="humantask.taskview.illegalaccess"/></p>
                <%
                        }
            }
        %>
            </div>

        </div>
</fmt:bundle>